## mingw-w64-qt6-multimedia-6.10.0-1.src.tar.zst

=== src/multimediaquick/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## MultimediaQuickPrivate Module:
#####################################################################

set(qml_files
    "Video.qml"
)

qt_internal_add_qml_module(MultimediaQuickPrivate
    URI "QtMultimedia"
    VERSION "${PROJECT_VERSION}"
    PAST_MAJOR_VERSIONS 5
    CLASS_NAME QMultimediaQuickModule
    PLUGIN_TARGET quickmultimedia
    NO_GENERATE_PLUGIN_SOURCE
    NO_PLUGIN_OPTIONAL
    DEPENDENCIES QtQuick
    CONFIG_MODULE_NAME multimediaquick
    INTERNAL_MODULE
    SOURCES
        qquickimagecapture.cpp qquickimagecapture_p.h
        qquickimagepreviewprovider.cpp qquickimagepreviewprovider_p.h
        qquickmediaplayer.cpp qquickmediaplayer_p.h
        qquickscreencapture.cpp qquickscreencapture_p.h
        qquicksoundeffect.cpp qquicksoundeffect_p.h
        qquickvideooutput.cpp qquickvideooutput_p.h
        qsgvideonode_p.cpp qsgvideonode_p.h
        qsgvideotexture.cpp qsgvideotexture_p.h
        qtmultimediaquickglobal_p.h
        qtmultimediaquicktypes.cpp qtmultimediaquicktypes_p.h
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
    QML_FILES
        ${qml_files}
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::MultimediaPrivate
        Qt::Quick
        Qt::QuickPrivate
)

target_sources(quickmultimedia PRIVATE multimedia_plugin.cpp)

=== examples/multimedia/audiorecorder/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(audiorecorder LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/multimedia/audiorecorder")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Multimedia Widgets)

qt_add_executable(audiorecorder
    audiolevel.cpp audiolevel.h
    audiorecorder.cpp audiorecorder.h audiorecorder.ui
    main.cpp
)

qt_add_ios_ffmpeg_libraries(audiorecorder)

set_target_properties(audiorecorder PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
    MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in
)

target_link_libraries(audiorecorder PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Multimedia
    Qt::Widgets
)

install(TARGETS audiorecorder
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== examples/multimedia/videographicsitem/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(videographicsitem LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/multimedia/videographicsitem")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Multimedia MultimediaWidgets Widgets)

qt_add_executable(videographicsitem
    main.cpp
    videoplayer.cpp videoplayer.h
)

set_target_properties(videographicsitem PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(videographicsitem PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Multimedia
    Qt::MultimediaWidgets
    Qt::Widgets
)

qt_add_ios_ffmpeg_libraries(videographicsitem)

install(TARGETS videographicsitem
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== src/3rdparty/tlsf/CMakeLists.txt ===
qt_internal_add_3rdparty_library(BundledTLSF
    STATIC
    SKIP_AUTOMOC
    SOURCES
        tlsf.h tlsf.cpp
    PUBLIC_INCLUDE_DIRECTORIES
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    ATTRIBUTION_FILE_DIR_PATHS
        .
    LIBRARIES
        Qt::Core
)

=== tests/manual/qml-minimal-camera/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(sidepanel LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/multimedia/qml-minimal-camera")

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    find_package(Qt6 REQUIRED COMPONENTS Core Gui Multimedia Qml Quick)
endif()

qt_add_executable( qml-minimal-camera WIN32 MACOSX_BUNDLE
    qml-minimal-camera.cpp
)

qt_add_qml_module( qml-minimal-camera
    URI QmlMinimalCamera
    NO_RESOURCE_TARGET_PATH
    QML_FILES
        "qml-minimal-camera.qml"
)

target_link_libraries( qml-minimal-camera PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
)

install(TARGETS  qml-minimal-camera
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

set_target_properties( qml-minimal-camera PROPERTIES
    MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in
)

=== src/plugins/multimedia/ffmpeg/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_find_package(EGL)
qt_find_package(VAAPI COMPONENTS VA DRM PROVIDED_TARGETS VAAPI::VAAPI MODULE_NAME multimedia QMAKE_LIB vaapi)

qt_internal_add_module(FFmpegMediaPluginImplPrivate
    STATIC
    INTERNAL_MODULE
    SOURCES
        qffmpeg.cpp qffmpeg_p.h
        qffmpegdefs_p.h
        qffmpegcodecstorage.cpp qffmpegcodecstorage_p.h
        qffmpegioutils.cpp qffmpegioutils_p.h
        qffmpegavaudioformat.cpp qffmpegavaudioformat_p.h
        qffmpegaudiodecoder.cpp qffmpegaudiodecoder_p.h
        qffmpegaudioinput.cpp qffmpegaudioinput_p.h
        qffmpegcodec.cpp qffmpegcodec_p.h
        qffmpegconverter.cpp qffmpegconverter_p.h
        qffmpeghwaccel.cpp qffmpeghwaccel_p.h
        qffmpegtextureconverter.cpp qffmpegtextureconverter_p.h
        qffmpegmediametadata.cpp qffmpegmediametadata_p.h
        qffmpegmediaplayer.cpp qffmpegmediaplayer_p.h
        qffmpegvideosink.cpp qffmpegvideosink_p.h
        qffmpegmediaformatinfo.cpp qffmpegmediaformatinfo_p.h
        qffmpegmediaintegration.cpp qffmpegmediaintegration_p.h
        qffmpegvideobuffer.cpp qffmpegvideobuffer_p.h
        qffmpegimagecapture.cpp qffmpegimagecapture_p.h
        qffmpegmediacapturesession.cpp qffmpegmediacapturesession_p.h
        qffmpegmediarecorder.cpp qffmpegmediarecorder_p.h
        qffmpegthread.cpp qffmpegthread_p.h
        qffmpegresampler.cpp qffmpegresampler_p.h
        qffmpegencodingformatcontext.cpp qffmpegencodingformatcontext_p.h
        qgrabwindowsurfacecapture.cpp qgrabwindowsurfacecapture_p.h
        qffmpegsurfacecapturegrabber.cpp qffmpegsurfacecapturegrabber_p.h

        qffmpegplaybackengine.cpp qffmpegplaybackengine_p.h
        playbackengine/qffmpegplaybackenginedefs_p.h
        playbackengine/qffmpegplaybackengineobject.cpp playbackengine/qffmpegplaybackengineobject_p.h
        playbackengine/qffmpegdemuxer.cpp playbackengine/qffmpegdemuxer_p.h
        playbackengine/qffmpegstreamdecoder.cpp playbackengine/qffmpegstreamdecoder_p.h
        playbackengine/qffmpegrenderer.cpp playbackengine/qffmpegrenderer_p.h
        playbackengine/qffmpegaudioframeconverter.cpp playbackengine/qffmpegaudioframeconverter_p.h
        playbackengine/qffmpegaudiorenderer.cpp playbackengine/qffmpegaudiorenderer_p.h
        playbackengine/qffmpegvideorenderer.cpp playbackengine/qffmpegvideorenderer_p.h
        playbackengine/qffmpegsubtitlerenderer.cpp playbackengine/qffmpegsubtitlerenderer_p.h
        playbackengine/qffmpegtime_p.h
        playbackengine/qffmpegtimecontroller.cpp playbackengine/qffmpegtimecontroller_p.h
        playbackengine/qffmpegmediadataholder.cpp playbackengine/qffmpegmediadataholder_p.h
        playbackengine/qffmpegcodeccontext.cpp playbackengine/qffmpegcodeccontext_p.h
        playbackengine/qffmpegpacket_p.h
        playbackengine/qffmpegframe_p.h
        playbackengine/qffmpegplaybackutils_p.h

        recordingengine/qffmpegaudioencoder_p.h
        recordingengine/qffmpegaudioencoder.cpp
        recordingengine/qffmpegaudioencoderutils_p.h
        recordingengine/qffmpegaudioencoderutils.cpp
        recordingengine/qffmpegencoderthread_p.h
        recordingengine/qffmpegencoderthread.cpp
        recordingengine/qffmpegencoderoptions_p.h
        recordingengine/qffmpegencoderoptions.cpp
        recordingengine/qffmpegmuxer_p.h
        recordingengine/qffmpegmuxer.cpp
        recordingengine/qffmpegrecordingengine_p.h
        recordingengine/qffmpegrecordingengine.cpp
        recordingengine/qffmpegencodinginitializer_p.h
        recordingengine/qffmpegencodinginitializer.cpp
        recordingengine/qffmpegrecordingengineutils_p.h
        recordingengine/qffmpegrecordingengineutils.cpp
        recordingengine/qffmpegvideoencoder_p.h
        recordingengine/qffmpegvideoencoder.cpp
        recordingengine/qffmpegvideoencoderutils_p.h
        recordingengine/qffmpegvideoencoderutils.cpp
        recordingengine/qffmpegvideoframeencoder_p.h
        recordingengine/qffmpegvideoframeencoder.cpp
    NO_GENERATE_CPP_EXPORTS
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
    PUBLIC_LIBRARIES
        Qt::MultimediaPrivate
        Qt::CorePrivate
    NO_PCH_SOURCES
        # compiled with different compiler options:
        # not used because `__NO_INLINE__' not defined [-Werror=invalid-pch]
        playbackengine/qffmpegaudioframeconverter.cpp

    SYSTEM_INCLUDE_DIRECTORIES
        ../../../3rdparty/signalsmith-stretch/
    ATTRIBUTION_FILE_DIR_PATHS
        ../../../3rdparty/signalsmith-stretch
)

if (LINUX OR ANDROID)
    # We have 2 options: link shared stubs to FFmpegMediaPluginImplPrivate vs
    # static compilation of the needed stubs to the FFmpeg plugin.
    # Currently, we chose the second option so that user could trivially
    # remove the FFmpeg libs we ship.
    # Set QT_LINK_STUBS_TO_FFMPEG_PLUGIN = TRUE to change the behavior.

    # set(QT_LINK_STUBS_TO_FFMPEG_PLUGIN TRUE)

    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/QtAddFFmpegStubs.cmake")
    qt_internal_multimedia_add_ffmpeg_stubs()
endif()

if (QT_FEATURE_vaapi)
    qt_internal_extend_target(FFmpegMediaPluginImplPrivate
        SOURCES
            qffmpeghwaccel_vaapi.cpp qffmpeghwaccel_vaapi_p.h
        NO_UNITY_BUILD_SOURCES
            # Conflicts with macros defined in X11.h, and Xlib.h
            qffmpeghwaccel_vaapi.cpp
        LIBRARIES
            EGL::EGL
    )

    list(FIND FFMPEG_STUBS "va" va_stub_index)
    if (NOT QT_LINK_STUBS_TO_FFMPEG_PLUGIN AND (FFMPEG_SHARED_LIBRARIES OR ${va_stub_index} EQUAL -1))
        target_compile_definitions(FFmpegMediaPluginImplPrivate PRIVATE Q_FFMPEG_PLUGIN_STUBS_ONLY)
        qt_internal_multimedia_find_vaapi_soversion()
        qt_internal_multimedia_add_private_stub_to_plugin("va")
    endif()
endif()


qt_internal_extend_target(FFmpegMediaPluginImplPrivate CONDITION APPLE
    SOURCES
        qffmpeghwaccel_videotoolbox.mm qffmpeghwaccel_videotoolbox_p.h
        darwin/qavfcamera.mm darwin/qavfcamera_p.h
        darwin/qavfsamplebufferdelegate.mm darwin/qavfsamplebufferdelegate_p.h

    NO_UNITY_BUILD_SOURCES
        qffmpeghwaccel_videotoolbox.mm # AVMediaType clash between libavformat and AVFoundation

    LIBRARIES
        ${FWAudioToolbox}
        ${FWAVFoundation}
        ${FWCoreMedia}
        ${FWCoreVideo}
        ${FWSecurity}
)

qt_internal_extend_target(FFmpegMediaPluginImplPrivate CONDITION MACOS
    SOURCES
        darwin/qavfscreencapture.mm darwin/qavfscreencapture_p.h
        darwin/qcgwindowcapture.mm darwin/qcgwindowcapture_p.h
        darwin/qcgcapturablewindows.mm darwin/qcgcapturablewindows_p.h
    LIBRARIES
        ${FWAppKit}
)

qt_internal_extend_target(FFmpegMediaPluginImplPrivate CONDITION WIN32
    SOURCES
        qwindowscamera.cpp qwindowscamera_p.h
        qffmpeghwaccel_d3d11.cpp qffmpeghwaccel_d3d11_p.h
        qgdiwindowcapture.cpp qgdiwindowcapture_p.h
        qffmpegscreencapture_dxgi.cpp qffmpegscreencapture_dxgi_p.h
        qwincapturablewindows.cpp qwincapturablewindows_p.h
    LIBRARIES
        Qt::MultimediaPrivate
        mf
        mfplat
        mfreadwrite
        mfuuid
)

qt_internal_extend_target(FFmpegMediaPluginImplPrivate CONDITION QT_FEATURE_cpp_winrt
    SOURCES
        qffmpegwindowcapture_uwp.cpp qffmpegwindowcapture_uwp_p.h
    LIBRARIES
        Dwmapi
        Dxva2
        windowsapp
)

if(QT_FEATURE_cpp_winrt)
    qt_internal_set_exceptions_flags(FFmpegMediaPluginImplPrivate ON)
endif()

qt_internal_extend_target(FFmpegMediaPluginImplPrivate CONDITION QT_FEATURE_xlib
    SOURCES
        qx11surfacecapture.cpp qx11surfacecapture_p.h
        qx11capturablewindows.cpp qx11capturablewindows_p.h
    LIBRARIES
        X11
        Xrandr
        Xext
)


if(QT_FEATURE_eglfs AND TARGET Qt::OpenGLPrivate)
    if(TARGET Qt::Quick)
        qt_internal_extend_target(FFmpegMediaPluginImplPrivate
            LIBRARIES Qt::Quick
        )
    else()
        # There's no "quick" feature we could test for in C++ code. Add a define for that.
        qt_internal_extend_target(FFmpegMediaPluginImplPrivate
            DEFINES QT_NO_QUICK
        )
    endif()

    qt_internal_extend_target(FFmpegMediaPluginImplPrivate
        SOURCES
            qeglfsscreencapture.cpp qeglfsscreencapture_p.h
            qopenglvideobuffer.cpp qopenglvideobuffer_p.h
        LIBRARIES
            Qt::OpenGLPrivate
    )
endif()

set_source_files_properties(qx11surfacecapture.cpp qx11capturablewindows.cpp # X headers
                            PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)

qt_internal_extend_target(FFmpegMediaPluginImplPrivate CONDITION QT_FEATURE_linux_v4l
    SOURCES
        qv4l2camera.cpp qv4l2camera_p.h
        qv4l2filedescriptor.cpp qv4l2filedescriptor_p.h
        qv4l2memorytransfer.cpp qv4l2memorytransfer_p.h
        qv4l2cameradevices.cpp qv4l2cameradevices_p.h
)

if (ANDROID)
    qt_internal_extend_target(FFmpegMediaPluginImplPrivate
        SOURCES
            qffmpeghwaccel_mediacodec.cpp qffmpeghwaccel_mediacodec_p.h
            qandroidcamera_p.h qandroidcamera.cpp
            qandroidvideodevices.cpp qandroidvideodevices_p.h
            qandroidvideoframebuffer_p.h  qandroidvideoframebuffer.cpp
            qandroidvideoframefactory_p.h qandroidvideoframefactory.cpp
            qandroidimagecapture_p.h qandroidimagecapture.cpp
            qandroidscreencapture_p.h qandroidscreencapture.cpp
            ../android/wrappers/jni/androidsurfacetexture_p.h
            ../android/wrappers/jni/androidsurfacetexture.cpp
        NO_UNITY_BUILD_SOURCES
            # Duplicate declration of JNI Classes using `Q_DECLARE_JNI_CLASS`
            qandroidcamera.cpp
            qandroidvideodevices.cpp
            qandroidvideoframebuffer.cpp
        INCLUDE_DIRECTORIES
            ${FFMPEG_DIR}/include
            ../android/wrappers/jni/
        LIBRARIES
            mediandk
            android
    )
endif()

# signalsmith-stretch is header-only and rather slow in debug builds. so let's optimize it:
if(GCC OR CLANG)
    set_source_files_properties(playbackengine/qffmpegaudioframeconverter.cpp PROPERTIES
        COMPILE_OPTIONS $<$<CONFIG:Debug>:-O3>)
elseif(MSVC)
    # we cannot just /O2, so we need to rely on pragma optimize here
    set_source_files_properties(playbackengine/qffmpegaudioframeconverter.cpp PROPERTIES
        COMPILE_DEFINITIONS $<$<CONFIG:Debug>:QT_MM_OPTIMIZE_DEBUG>
    )
endif()


# TODO: get libs from FindFFmpeg.cmake
set(ffmpeg_libs FFmpeg::avformat FFmpeg::avcodec FFmpeg::swresample FFmpeg::swscale FFmpeg::avutil)

if (QT_DEPLOY_FFMPEG AND NOT BUILD_SHARED_LIBS AND NOT UIKIT)
    message(FATAL_ERROR "QT_DEPLOY_FFMPEG is not implemented yet for static builds")
endif()

if (QT_DEPLOY_FFMPEG AND FFMPEG_SHARED_LIBRARIES AND (BUILD_SHARED_LIBS OR UIKIT))
    include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/QtDeployFFmpeg.cmake")
    qt_internal_multimedia_copy_or_install_ffmpeg()
endif()

if( NOT (UIKIT AND FFMPEG_SHARED_LIBRARIES) )
    qt_internal_extend_target(FFmpegMediaPluginImplPrivate PUBLIC_LIBRARIES ${ffmpeg_libs})
else()
    # applications need to link against the ffmpeg libs via qt_add_ios_ffmpeg_libraries
    foreach(ffmpeg_lib IN LISTS ffmpeg_libs)
        qt_internal_add_target_include_dirs(FFmpegMediaPluginImplPrivate ${ffmpeg_lib})
        target_include_directories(FFmpegMediaPluginImplPrivate PUBLIC
            "$<TARGET_PROPERTY:${ffmpeg_lib},INTERFACE_COMPILE_DEFINITIONS>")
    endforeach()
endif()

qt_internal_add_plugin(QFFmpegMediaPlugin
    OUTPUT_NAME ffmpegmediaplugin
    PLUGIN_TYPE multimedia
    SOURCES
        qffmpegplugin.cpp
        ffmpeg.json
    LIBRARIES
        Qt::FFmpegMediaPluginImplPrivate
        Qt::MultimediaPrivate
)

if (ANDROID)
    set_property(TARGET QFFmpegMediaPlugin APPEND PROPERTY QT_ANDROID_LIB_DEPENDENCIES
        ${INSTALL_PLUGINSDIR}/multimedia/libplugins_multimedia_ffmpegmediaplugin.so
    )

=== src/plugins/multimedia/windows/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_plugin(QWindowsMediaPlugin
    OUTPUT_NAME windowsmediaplugin
    PLUGIN_TYPE multimedia
    SOURCES
        common/mfmetadata.cpp common/mfmetadata_p.h
        decoder/mfaudiodecodercontrol.cpp decoder/mfaudiodecodercontrol_p.h
        decoder/mfdecodersourcereader.cpp decoder/mfdecodersourcereader_p.h
        decoder/mfdecodersourcereadercallback.cpp decoder/mfdecodersourcereadercallback_p.h
        evr/evrcustompresenter.cpp evr/evrcustompresenter_p.h
        evr/evrd3dpresentengine.cpp evr/evrd3dpresentengine_p.h
        evr/evrhelpers.cpp evr/evrhelpers_p.h
        evr/evrvideowindowcontrol.cpp evr/evrvideowindowcontrol_p.h
        mfstream.cpp mfstream_p.h
        player/mfactivate.cpp player/mfactivate_p.h
        player/mfevrvideowindowcontrol.cpp player/mfevrvideowindowcontrol_p.h
        player/mfplayercontrol.cpp player/mfplayercontrol_p.h
        player/mfplayersession.cpp player/mfplayersession_p.h
        player/mfvideorenderercontrol.cpp player/mfvideorenderercontrol_p.h
        mediacapture/qwindowscamera.cpp
        mediacapture/qwindowscamera_p.h
        mediacapture/qwindowsimagecapture.cpp
        mediacapture/qwindowsimagecapture_p.h
        mediacapture/qwindowsmediacapture.cpp
        mediacapture/qwindowsmediacapture_p.h
        mediacapture/qwindowsmediadevicereader.cpp
        mediacapture/qwindowsmediadevicereader_p.h
        mediacapture/qwindowsmediadevicesession.cpp
        mediacapture/qwindowsmediadevicesession_p.h
        mediacapture/qwindowsmediaencoder.cpp
        mediacapture/qwindowsmediaencoder_p.h
        qwindowsformatinfo.cpp qwindowsformatinfo_p.h
        qwindowsintegration.cpp qwindowsintegration_p.h
        sourceresolver.cpp sourceresolver_p.h
    INCLUDE_DIRECTORIES
        audio
        common
        decoder
        evr
        player
        mediacapture
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
    LIBRARIES
        Qt::MultimediaPrivate
        Qt::CorePrivate
        Qt::Concurrent
        uuid
        d3d9
        dxva2
        evr
        gdi32
        ksuser
        mf
        mfcore
        mfplat
        mfreadwrite
        mfuuid
        ole32
        oleaut32
        propsys
        shlwapi
        strmiids
        amstrmid
        user32
        winmm
        wmcodecdspuuid
)

=== tests/auto/integration/qmediarecorderbackend/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_test(tst_qmediarecorderbackend
    SOURCES
        tst_qmediarecorderbackend.cpp
    LIBRARIES
        Qt::MultimediaPrivate
        Qt::MultimediaTestLibPrivate
)

=== tests/auto/integration/qquickvideooutput_window/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qdeclarativevideooutput_window Test:
#####################################################################

qt_internal_add_test(tst_qquickvideooutput_window
    SOURCES
        tst_qquickvideooutput_window.cpp
    INCLUDE_DIRECTORIES
        ../../../../src/imports/multimedia
    LIBRARIES
        Qt::Gui
        Qt::MultimediaPrivate
        Qt::MultimediaQuickPrivate
        Qt::Qml
        Qt::Quick
)

# Resources:
set(qml_resource_files
    "main.qml"
)

qt_internal_add_resource(tst_qquickvideooutput_window "qml"
    PREFIX
        "/"
    FILES
        ${qml_resource_files}
)

=== tests/auto/integration/qsoundeffect_concurrent/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_test(tst_qsoundeffect_concurrent
    SOURCES
        tst_qsoundeffect_concurrent.cpp
    LIBRARIES
        Qt::Core
        Qt::MultimediaPrivate
    TESTDATA "double-drop.wav"
    BUILTIN_TESTDATA
)

=== tests/auto/unit/multimedia/qaudioformat/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qaudioformat Test:
#####################################################################

qt_internal_add_test(tst_qaudioformat
    SOURCES
        tst_qaudioformat.cpp
    LIBRARIES
        Qt::MultimediaPrivate
)

=== tests/auto/unit/multimedia/qscreencapture/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qscreencapture Test:
#####################################################################

qt_internal_add_test(tst_qscreencapture
    SOURCES
        tst_qscreencapture.cpp
    INCLUDE_DIRECTORIES
        ../../mockbackend
    LIBRARIES
        Qt::Core
        Qt::MultimediaPrivate
        Qt::MockMultimediaPlugin
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-multimedia
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-wmf")
_qtver=6.10.0
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Classes for audio, video, radio and camera functionality (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtmultimedia.git"
msys2_references=(
  'archlinux: qt6-multimedia'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             #"${MINGW_PACKAGE_PREFIX}-pulseaudio"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-export-some-constexpr-variables.patch)
sha256sums=('04424021cf0d1d19799f5967310d484d1afa6fdd0b31725d0ee7608d2eef1126'
            'e1694338779eb499341618c62d11f832f2b7f1f90c8a20345932530a61203105')

prepare() {
  cd "${srcdir}"/${_pkgfn}
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    patch -p1 -i "${srcdir}"/001-export-some-constexpr-variables.patch
  fi
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DFEATURE_wmf=ON \
    -DFEATURE_ffmpeg=ON \
    -DFEATURE_gstreamer=OFF \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-multimedia() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
           "${MINGW_PACKAGE_PREFIX}-qt6-multimedia-ffmpeg")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
              "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
              "${MINGW_PACKAGE_PREFIX}-qt6-multimedia-wmf")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}

  # Split plugins
  rm -r "${pkgdir}${MINGW_PREFIX}/share/qt6/plugins"
  rm "${pkgdir}${MINGW_PREFIX}"/lib/cmake/Qt6Multimedia/Qt6Q{FFmpeg,Windows}MediaPlugin*
  rm -r "${pkgdir}${MINGW_PREFIX}"/lib/cmake/Qt6FFmpegMediaPluginImplPrivate
  rm -r "${pkgdir}${MINGW_PREFIX}"/include/qt6/QtFFmpegMediaPluginImpl/
  rm "${pkgdir}${MINGW_PREFIX}"/lib/libQt6FFmpegMediaPluginImpl.a
  rm "${pkgdir}${MINGW_PREFIX}"/share/qt6/metatypes/qt6ffmpegmediapluginimplprivate_metatypes.json
  rm "${pkgdir}${MINGW_PREFIX}"/share/qt6/mkspecs/modules/qt_lib_ffmpegmediapluginimpl_private.pri
  rm "${pkgdir}${MINGW_PREFIX}"/share/qt6/modules/FFmpegMediaPluginImplPrivate.json
}

package_qt6-multimedia-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

package_qt6-multimedia-ffmpeg() {
  pkgdesc='FFMpeg backend for qt6-multimedia'
  depends=("${MINGW_PACKAGE_PREFIX}-ffmpeg"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")

  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}/src/plugins/multimedia/ffmpeg

  find "${pkgdir}${MINGW_PREFIX}" -type f -name '*.debug' -delete
}

package_qt6-multimedia-wmf() {
  pkgdesc='Windows Media Foundation backend for qt6-multimedia'
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}")

  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}/src/plugins/multimedia/windows

  find "${pkgdir}${MINGW_PREFIX}" -type f -name '*.debug' -delete
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
